import Tutorial7
import LSystem
import Pictures
import System.Random
import System.IO
import System.IO.Unsafe

main :: IO ()
main = do
	display $ Turn (-80) :#: background 30 (0, 0, 0) (0,0,0.2) 16000 4000 :#: GrabPen Inkless
	 :#: Go (7000) :#: Turn (-90) :#: Go 500 :#:  hilbert 7 :#: drawLasers :#: GrabPen Inkless
	 :#: Go (-4000) :#: Turn (121.5) :#: aLongLongTimeAgo

getRandom :: (Float, Float) -> Float
getRandom range = unsafePerformIO(getStdRandom (randomR range) :: IO Float)



--background Starwars sky

type Stars = Float
type PenColour = (Float, Float, Float)
type Width = Distance
type Height = Distance

background :: Stars -> PenColour -> PenColour -> Width -> Height -> Command
background stars c1 c2 w 0 = Sit
background stars c1 c2 w h = (drawLine c1 w stars) :#: turnRight :#: (drawLine c1 w stars) :#: turnLeft :#: 
						(background (stars) (blend c1 c2) c2 w (h - 1))
					where
				drawLine :: PenColour -> Width -> Stars -> Command
				drawLine (r,g,b) w stars | drawStar stars = GrabPen (Colour r g b) :#: Go (randy) :#: 
										GrabPen white :#: Turn 1 :#: Go 20 :#: GrabPen (Colour r g b) :#:
									 	Go (w - 20 - randy)
								 | otherwise = GrabPen (Colour r g b) :#: Go w
				
							where
								drawStar :: Stars -> Bool
								drawStar stars = ((getRandom (1, 100))) < stars

								randy = (getRandom (1, w))

				blend :: PenColour -> PenColour -> PenColour
				blend (r1, g1, b1) (r2, g2, b2) = ((f r1 r2), (f g1 g2), (f b1 b2))
									where
										f a b = a - ((a - b)/( h))

				turnRight = Turn 90 :#: Go 1 :#: Turn 90
				turnLeft  = Turn (-90) :#: Go 1 :#: Turn (-90) 

--letters
lH = x
lW = x/4
yellowPen = (Colour 0.9 0.9 0)
angle= 65
x = 300

drawLasers =  Turn 25 :#: GrabPen red :#: laser l1 15 :#:
	 Turn (-92) :#: GrabPen Inkless :#: Go 2700 :#: Turn 80 :#: GrabPen red :#: Turn (-20) :#: laser l2 15
		where
			l1 = 9000
			l2 = 9000

laser :: Distance -> Angle -> Command
laser d a = Turn (a/2) :#: laser' a :#: Turn (-a-(a/2))
	where
		laser' :: Angle -> Command
		laser' a| a > 0 = Go d :#: Go (-d) :#: Turn (incA) :#: laser' (a - incA)
	    		 | a < 0 = Sit

		incA = a/100

aLongLongTimeAgo = joinLetters $ putGaps [a,space,l,o,n,g,space,l,o,n,g,space,t,i,m,e,space,a,g,o,dot,dot,dot]

putGaps :: [Command] -> [Command]
putGaps [] = [Sit]
putGaps (x:xs) = if  isLetter x then x:gap:(putGaps xs) else x:(putGaps xs)
	where
		isLetter :: Command -> Bool
		isLetter x = or(map (==x) [a, l, m, n, o, i, e, t, g, dot])  

joinLetters :: [Command] -> Command
joinLetters [] = Sit 
joinLetters (x:xs) = x :#: joinLetters xs

a = GrabPen yellowPen :#: Turn (angle) :#: Go side :#: Go (-side/2) :#: Turn (-angle) :#: Go bar :#: Turn (180 - angle) :#: Go (side/2) :#: Go (-side) :#: Turn (-(180-angle))
	where 
		side = sqrt (lH^2 + (lW/2)^2)
		angle = atan (lH/lW) * 57.3
		bar = x/4

space = GrabPen Inkless :#: Go x
gap = GrabPen Inkless :#: Go (x/4)
dot = let side = (x/10) in
	GrabPen yellowPen :#: Go side :#: Turn 90 :#: Go side :#: Turn 90 :#: Go side :#: Turn 90 :#: Go side :#: Turn 90 :#: Go side

l = GrabPen yellowPen :#: Turn (90) :#: Go x :#: Go (-x) :#: Turn (-90) :#: Go (x/2)
o = GrabPen yellowPen :#: Go (x/2) :#: Turn (90) :#: Go (x) :#: Turn (90) :#: Go (x/2) :#: Turn (90) :#: Go x :#: Turn (90) :#: Go (x/2)
n = GrabPen yellowPen :#: Turn (90) :#: Go x :#: Turn (angle + 180) :#: Go (side) :#: Turn (-180 -angle) :#: Go x:#: Go (-x) :#: Turn (-90)
	where
		side = sqrt (x^2 + (x/2)^2)
		angle = atan ((x/2)/x) * 57.3
g = GrabPen yellowPen :#: Turn (90) :#: Go x :#: Turn (- 90) :#: Go (x/2) :#: Go (-(x/2)) :#: Turn (90) :#: Go (-x) :#: Turn (-90) :#: Go (x/2) :#: Turn 90 :#: Go (x/4) :#: Go (-(x/2)) :#: Go (x/4 ):#: Turn (-90)
t = GrabPen Inkless :#: Turn 90 :#: Go x :#: Turn (-90) :#: GrabPen yellowPen :#: Go (x/2) :#: Go (-(x/4)) :#: Turn (-90) :#: Go x :#: Turn 90 :#: GrabPen Inkless :#: Go (x/4)
i = GrabPen yellowPen :#: Turn 90 :#: Go x :#: Go (-x) :#: Turn (-90)
m = GrabPen yellowPen :#: Turn 90 :#: Go x :#: Turn (180 + angle) :#: Go side :#: Turn (2*angle) :#: Go side :#: Turn (180 + angle) :#: Go x :#: Turn (90)
	where
		side = sqrt (2*(x/4)^2)
		angle = atan 1 * 57.3
e = GrabPen yellowPen :#: Turn 90 :#: Go x :#: Turn (-90) :#: Go (x/2) :#: Go (-(x/2)) :#: Turn (-90):#: Go (x/2) :#: Turn (90) :#: Go (x/2) :#: Go (-(x/2)) :#: Turn (-90) :#: Go (x/2) :#: Turn 90 :#: Go (x/2)
